# -*- coding:Latin-1 -*-
#Test de prsentation graphique de Ngen

from Tkinter import *
from random import randrange
class Appli:
	def __init__(self):
		self.fen=Tk()
		#self.fen.geometry("77x51")
		self.fen.title('NGen4.0')
		self.fen.resizable(width=FALSE,height=FALSE)
		#variables pour les BDD
		self.p1=[]
		self.p2=[]
		self.p3=[]
		self.p4=[]
		#++++LabelFrame de race selectionne
		self.selectedraceframe=LabelFrame(self.fen,text='Race selectionne ou  ajouter',padx=20,pady=5)
		self.selectedraceframe.grid(row=0,column=0)
		#Entree indiquant la race selectionnee
		self.raceselstrvar= StringVar()#objet variable pour la selection de race dans l'index de races
		self.racesel = Entry(self.selectedraceframe,width=32,textvariable=self.raceselstrvar,bg='white')
		self.racesel.grid(row=0, column=0, columnspan=2)
		#bouton de chargement de la race
		self.racebuttonload=Button(self.selectedraceframe, text='Charger BDD', command=self.loadrace)
		self.racebuttonload.grid(row=1,column=0)
		#bouton pour ajouter une race
		self.racebuttonadd=Button(self.selectedraceframe, text='Ajouter Race', command=self.addrace)
		self.racebuttonadd.grid(row=1, column=1)
		#++++LabelFrame des operation de BDD
		self.bddops=LabelFrame(self.fen,text='Manipulation des BDD',padx=47,pady=5)
		self.bddops.grid(row=1,column=0)
		#prereglage pour l'tablissement des boutons radios pour la selection des BDD
		self.pliste = ['P1','P2','P3','P4']
		self.pstrvar = StringVar()#objet variable contenant la chaine P1 ou P2 etc pour l'ouverture des BDD correspondantes
		self.pstrvar.set('P1')
		#etablissement des boutons radios pour la selec des BDD
		i=0
		for p in self.pliste:
			self.pradbutton = Radiobutton(self.bddops, text=p, variable=self.pstrvar, value=p)
			self.pradbutton.grid(row=0, column=i)		#grid
			i += 1
		#boutons de sauvegarde/chargement de la BDD selectionnee
		self.pbuttonop = Button(self.bddops, text='Ouvrir', command=self.openbdd)
		self.pbuttonsa = Button(self.bddops, text='Sauveg.', command=self.savebdd)
		self.pbuttonop.grid(row=1,column=0,columnspan=2)		#grid
		self.pbuttonsa.grid(row=1,column=2,columnspan=4)		#grid
		#+++++++RACE INDEX
		#++++LabelFrame de l'index des races
		self.raceindexframe=LabelFrame(self.fen,text='Index des races',padx=5,pady=10)
		self.raceindexframe.grid(row=0,column=1,rowspan=2)
		#boutons pour selectioner une race de l'index des races
		self.racebuttonsel=Button(self.raceindexframe, text='Selectionner', command=self.selrace)
		self.racebuttonsel.grid(row=1,column=0)			#grid
		#liste + scrollbar de l'index des races
		self.racelistframe = Frame(self.raceindexframe)
		self.racelist = Listbox(self.racelistframe, height=5)
		self.racelistscroll = Scrollbar(self.racelistframe, command=self.racelist.yview)
		self.racelist.configure(yscrollcommand=self.racelistscroll.set)
#		self.racelist.place(x=320,y=5)
#		self.racelistscroll.place(x=470,y=5)
		self.racelistframe.grid(row=0,column=0)
		self.racelist.pack(side=LEFT)
		self.racelistscroll.pack(side=LEFT,fill='y')
		#ajout des entres de RaceIndex.txt dans la liste rlst (r pour race, lst pour list)
		tmprload=open('./RaceIndex/RaceIndex.txt', 'r')
		self.rlst=tmprload.read().split(' ')
		print self.rlst
		n=0
		for i in self.rlst:
			if (i != '') and (i != '\n') and (i != ' '):
				if i[len(i)-1] == '\n':
					self.rlst[n]=i[:(len(i)-1)]
					i=i[:(len(i)-1)]
				self.racelist.insert('end', i)
				n += 1
		tmprload.close()
		#+++++++MainField
		#Champ texte resultat de generationsdes resultats/affichage des BDD, et scrollbar
		self.mainfieldframe = LabelFrame(self.fen,text='Champ de texte',padx=5,pady=5)#support pour mainfield
		self.mainfield = Text(self.mainfieldframe, setgrid=1, height=20, width=33, bg='white')
		self.mainfield.bind("<F1>", self.copytomemo)
		self.mainfieldscroll = Scrollbar(self.mainfieldframe, command=self.mainfield.yview)
		self.mainfield.configure(yscrollcommand=self.mainfieldscroll.set)
		self.mainfieldframe.grid(row=2,column=0)
		self.mainfield.pack(side=LEFT)
		self.mainfieldscroll.pack(side=LEFT,fill='y')
		#+++++++MEMO
		#==LabelFrame
		self.memolabelf=LabelFrame(self.fen,text='Memo',padx=5,pady=5)
		self.memolabelf.grid(row=2,column=1)
		#==Frame + Text + ScrollBar
		self.memoframe=Frame(self.memolabelf)
		self.memoframe.grid(row=0)
		self.memotxt=Text(self.memoframe, height=15,width=20,bg='white')
		self.memotxt.bind("<F1>", self.copytomf)
		self.memoscroll=Scrollbar(self.memoframe,command=self.memotxt.yview)
		self.memotxt.configure(yscrollcommand=self.memoscroll.set)
		self.memotxt.pack(side=LEFT)
		self.memoscroll.pack(side=LEFT,fill='y')
		#==Buttons
		Button(self.memolabelf,text='Sauvegarder',command=self.memosave).grid(row=1)
		Button(self.memolabelf,text='Ouvrir',command=self.memoload).grid(row=2)
		#+++++++GENERATION
		self.genframe=LabelFrame(self.fen,text='GENERATION',padx=5,pady=5)
		self.genframe.grid(row=3,column=0,columnspan=2)
		#++++LabelFrame Operations de gnration
		self.genopsframe=LabelFrame(self.genframe,text='Opration de gnration',padx=5, pady=5)
		self.genopsframe.pack(side=RIGHT,padx=5)
		#boutons de generations et entre du nombres de rsultat pour random
		self.genbuttongen= Button(self.genopsframe,text='Generer', command=self.alertposs)
		self.genbuttonrand= Button(self.genopsframe,text='Aleatoire', command=self.randgen)
		self.genrandstrvar= StringVar()
		self.genrandstrvar.set('20')
		self.genentryrand= Entry(self.genopsframe, width=3,textvariable=self.genrandstrvar,bg='white')
		#self.genbuttongen.place(x=10,y=400)
		#self.genbuttonrand.place(x=120,y=400)
		#self.genentryrand.place(x=200,y=405)
		self.genbuttongen.pack(side=LEFT)
		self.genbuttonrand.pack(side=LEFT)
		self.genentryrand.pack(side=LEFT)
		#checkboxes des paramtre de gnrations
		#++++LabelFrame particule
		self.particleframe=LabelFrame(self.genframe,text='particules',padx=5,pady=5)
		self.particleframe.pack(side=TOP,padx=5)
		self.part1intvar= IntVar()
		self.part1chck= Checkbutton(self.particleframe, text='1', variable=self.part1intvar)
		self.part2intvar= IntVar()
		self.part2chck= Checkbutton(self.particleframe, text='2', variable=self.part2intvar)
		self.part3intvar= IntVar()
		self.part3chck= Checkbutton(self.particleframe, text='3', variable=self.part3intvar)
		self.part4intvar= IntVar()
		self.part4chck= Checkbutton(self.particleframe, text='4', variable=self.part4intvar)
		partX=7
		self.part1chck.pack(side=LEFT,padx=partX)
		self.part2chck.pack(side=LEFT,padx=partX)
		self.part3chck.pack(side=LEFT,padx=partX)
		self.part4chck.pack(side=LEFT,padx=partX)
		#++++LabelFrame des espaces
		self.spacesframe=LabelFrame(self.genframe,text='Espaces entre les particules',padx=25,pady=5)
		self.spacesframe.pack(side=BOTTOM,padx=5)
		self.space1intvar= IntVar()
		self.space1chck= Checkbutton(self.spacesframe, text='1-2', variable=self.space1intvar)
		self.space2intvar= IntVar()
		self.space2chck= Checkbutton(self.spacesframe, text='2-3', variable=self.space2intvar)
		self.space3intvar= IntVar()
		self.space3chck= Checkbutton(self.spacesframe, text='3-4', variable=self.space3intvar)
		partX2=2
		self.space1chck.pack(side=LEFT,padx=partX2)
		self.space2chck.pack(side=LEFT,padx=partX2)
		self.space3chck.pack(side=LEFT,padx=partX2)
		#+++++++LANCER DE DES
		#++++LabelFrame
		self.lancerframe=LabelFrame(self.fen,text='Lancer de ds', padx=5,pady=5)
		self.lancerframe.grid(row=4,column=0,columnspan=2)
		#frame, entree et labels
		self.nbdesframe=Frame(self.lancerframe)
		self.nbdesframe.grid(row=0, column=0)
		Label(self.nbdesframe,text='Nb de ds : ').pack(side=LEFT)
		self.nbdesentry=Entry(self.nbdesframe,width=2,bg='white')
		self.nbdesentry.pack(side=LEFT)
		self.valdesframe=Frame(self.lancerframe)
		self.valdesframe.grid(row=0,column=1)
		Label(self.valdesframe,text='De : ').pack(side=LEFT)
		self.valdesentry=Entry(self.valdesframe,width=2, bg='white')
		self.valdesentry.pack(side=LEFT)
		Button(self.lancerframe,text='Lancer', command=self.lancer).grid(row=0,column=2)
		self.desreslab=Label(self.lancerframe,text='Rsultat :')
		self.desreslab.grid(row=1,column=0,columnspan=3,pady=5)
		


#-----------METHODES---------

	#----methode de sel race
	def selrace(self):
		tmp = self.racelist.curselection()
		self.raceselstrvar.set(self.racelist.get(tmp))
	#----methode de del race
	def delrace(self):
		tmp = self.racelist.curselection()
		tmp2=int(tmp[0])
		del(self.rlst[tmp2])
		self.racelist.delete(tmp)
		tmprsave=open('./RaceIndex/RaceIndex.txt', 'w')
		for i in self.rlst:
			if i != self.rlst[-1]:
				tmprsave.write(i+' ')
			else:
				tmprsave.write(i)
		tmprsave.close()
	#----methode pour ajouter un race
	def addrace(self):
		if self.racesel.get() not in self.rlst:
			tmprsave=open('./RaceIndex/RaceIndex.txt', 'w')
			self.racelist.delete(0, END)
			self.rlst.append(self.racesel.get())
			self.rlst.sort()
			for i in self.rlst:
				self.racelist.insert('end', i)
				if i != self.rlst[-1]:
					tmprsave.write(i+' ')
				else:
					tmprsave.write(i)
			tmprsave.close()
	#----methode pour ouvrir une BDD
	def openbdd(self):
		try:	#essaye d'ouvrir le fichier correspondant
			tmpop=open('./bdd/'+self.racesel.get()+'_'+self.pstrvar.get()+'.txt', 'r')
			tmplst = tmpop.read().split('\n')
			tmpop.close()
			for i in range(len(tmplst)): #recherche des entre inutile et supresssion de ces dernires
				if (tmplst[i] == '') or (tmplst[i] == ' ') or (tmplst[i] == '\n'):
					del(tmplst[i])
			print tmplst
			try:	#essaye d'effacer le texte de mainfield
				self.mainfield.delete(1.0, END)	#l'index d'un texte commence par 1.0 pour une 	
								#compatibilite av d'autres trucs (ligne.colonne)
			except:	#si pas de texte
				print 'pas de texte  effacer'
			for i in tmplst: #phase d'insertion de tmplst dans mainfield
				if i != tmplst[-1]:
					self.mainfield.insert(END, i+'\n')
				else:
					self.mainfield.insert(END, i)
			tmplst=[]
		except:	#si pas de fichier
			print 'pas de fichier'
	#----methode pour sauvegarder une BDD
	def savebdd(self):
		tmpsa=open('./bdd/'+self.racesel.get()+'_'+self.pstrvar.get()+'.txt', 'w')
		tmplst=self.mainfield.get(1.0, END).split('\n')
		print tmplst
		#recherche des entre inutile et supresssion de ces dernires
		for i in range(len(tmplst)):
				if (tmplst[i] == '') or (tmplst[i] == ' ') or (tmplst[i] == '\n'):
					del(tmplst[i])
		#elimination des doublons
		n = 0
		while n < len(tmplst):
			o = 0
			while o < len(tmplst):
				if (o != n) and (tmplst[n] == tmplst[o]):
					del(tmplst[o])
				o += 1
			n += 1
		#phase d'insertion de tmplst dans le nouveau fichier texte
		for i in tmplst: 
				if i != tmplst[-1]:
					tmpsa.write(i+'\n')
				else:
					tmpsa.write(i)
		tmplst=[]
		tmpsa.close()
	#----Methode pour charger la race selectionne
	def loadrace(self):
		try:	#essaye d'ouvrir le fichier
			tmpop=open('./bdd/'+self.racesel.get()+'_P1.txt', 'r')
			self.p1 = tmpop.read().split('\n')
			tmpop.close()
			for i in range(len(self.p1)): #recherche des entre inutile et supresssion de ces dernires
				if (self.p1[i] == '') or (self.p1[i] == ' ') or (self.p1[i] == '\n'):
					del(self.p1[i])
			if len(self.p1)== 1:
				if self.p1[0] in ['', ' ', '\n']:
					self.p1= ['']
			elif len(self.p1)== 0:
				self.p1= ['']
		except:	#si pas possible, liste gale valeur rien
			self.p1= ['']
		try:
			tmpop=open('./bdd/'+self.racesel.get()+'_P2.txt', 'r')
			self.p2 = tmpop.read().split('\n')
			tmpop.close()
			for i in range(len(self.p2)): #recherche des entre inutile et supresssion de ces dernires
				if (self.p2[i] == '') or (self.p2[i] == ' ') or (self.p2[i] == '\n'):
					del(self.p2[i])
			if len(self.p2)== 1:
				if self.p2[0] in ['', ' ', '\n']:
					self.p2= ['']
			elif len(self.p2)== 0:
				self.p2= ['']
		except:
			self.p2= ['']
		try:
			tmpop=open('./bdd/'+self.racesel.get()+'_P3.txt', 'r')
			self.p3 = tmpop.read().split('\n')
			tmpop.close()
			for i in range(len(self.p3)): #recherche des entre inutile et supresssion de ces dernires
				if (self.p3[i] == '') or (self.p3[i] == ' ') or (self.p3[i] == '\n'):
					del(self.p3[i])
			if len(self.p3)== 1:
				if self.p3[0] in ['', ' ', '\n']:
					self.p3= ['']
			elif len(self.p3)== 0:
				self.p3= ['']
		except:
			self.p3= ['']
		try:
			tmpop=open('./bdd/'+self.racesel.get()+'_P4.txt', 'r')
			self.p4 = tmpop.read().split('\n')
			tmpop.close()
			for i in range(len(self.p4)): #recherche des entre inutile et supresssion de ces dernires
				if (self.p4[i] == '') or (self.p4[i] == ' ') or (self.p4[i] == '\n'):
					del(self.p4[i])
			if len(self.p4)== 1:
				if self.p4[0] in ['', ' ', '\n']:
					self.p4= ['']
			elif len(self.p4)== 0:
				self.p4= ['']
		except:
			self.p4= ['']
		print self.p1
		print self.p2
		print self.p3
		print self.p4

	#----Methode pour MEMOSAVE
	def memosave(self):
		memosave=open('Memo.txt', 'w')
		filetext=self.memotxt.get(1.0,END)
		memosave.write(filetext)
		memosave.close()
	#----Methode pour MEMOLOAD
	def memoload(self):
		memoload=open('Memo.txt', 'r')
		filetext=memoload.read()
		self.memotxt.delete(1.0, END)
		self.memotxt.insert(END, filetext)
		memoload.close()
	#----Methode de copie > memo
	def copytomemo(self, event):
		print 'event Ok'
		line = self.mainfield.index(INSERT)
		print line
		line = line.split('.')
		print line
		indstart = line[0]+'.0'
		indend=line[0]+'.end'
		text=self.mainfield.get(indstart,indend)
		self.memotxt.insert(END, text+'\n')
	#----Methode de copie > Mainfield
	def copytomf(self, event):
		print 'event Ok'
		line = self.memotxt.index(INSERT)
		print line
		line = line.split('.')
		print line
		indstart = line[0]+'.0'
		indend=line[0]+'.end'
		text=self.memotxt.get(indstart,indend)
		self.mainfield.insert(END, text+'\n')

	#----Alerte signalant les possibillits
	def alertposs(self):
		self.alert=Toplevel()
		self.alert.title("Confirmation")
		self.alert.grab_set()
		#self.alert.positionfrom(who=self.fen)
		#check des particules
		if self.part1intvar.get() == 1:
			p1=self.p1
		else:
			p1=['']
		if self.part2intvar.get() == 1:
			p2=self.p2
		else:
			p2=['']
		if self.part3intvar.get() == 1:
			p3=self.p3
		else:
			p3=['']
		if self.part4intvar.get() == 1:
			p4=self.p4
		else:
			p4=['']
		nbposs=len(p1)*len(p2)*len(p3)*len(p4)
		textposs='le nombre de possibily est de '+str(nbposs)+'\n Continuer ?'
		Label(self.alert,text=textposs).grid(row=0, column=0,columnspan=2)
		Button(self.alert,text='Oui',command=self.generate).grid(row=1,column=0)
		Button(self.alert,text='Non',command=self.alert.destroy).grid(row=1,column=1)
	#----Methode pour generer la liste de toutes le possibilits
	def generate(self):
		self.alert.destroy()
		#check des particules
		if self.part1intvar.get() == 1:
			p1=self.p1
		else:
			p1=['']
		if self.part2intvar.get() == 1:
			p2=self.p2
		else:
			p2=['']
		if self.part3intvar.get() == 1:
			p3=self.p3
		else:
			p3=['']
		if self.part4intvar.get() == 1:
			p4=self.p4
		else:
			p4=['']
		#check des espaces
		if self.space1intvar.get() == 1:
			space1=' '
		else:
			space1=''
		if self.space2intvar.get() == 1:
			space2=' '
		else:
			space2=''
		if self.space3intvar.get() == 1:
			space3=' '
		else:
			space3=''
		#supression du texte dans mainfield
		self.mainfield.delete(1.0, END)
		#operation de generation:
		for i in p1:
			for j in p2:
				for k in p3:
					for l in p4:
						txt= i+space1+j+space2+k+space3+l
						self.mainfield.insert(END, txt)
						if p4 != ['']:
							self.mainfield.insert(END, '\n')
					if p3 != ['']:
						self.mainfield.insert(END, '\n')
				if p2 != ['']:
					self.mainfield.insert(END, '\n')
			if p1 != ['']:
				self.mainfield.insert(END, '\n')
	#----Methode de generation alatoire
	def randgen(self):
		#check des particules
		if self.part1intvar.get() == 1:
			p1=self.p1
		else:
			p1=['']
		if self.part2intvar.get() == 1:
			p2=self.p2
		else:
			p2=['']
		if self.part3intvar.get() == 1:
			p3=self.p3
		else:
			p3=['']
		if self.part4intvar.get() == 1:
			p4=self.p4
		else:
			p4=['']
		#check des espaces
		if self.space1intvar.get() == 1:
			space1=' '
		else:
			space1=''
		if self.space2intvar.get() == 1:
			space2=' '
		else:
			space2=''
		if self.space3intvar.get() == 1:
			space3=' '
		else:
			space3=''
		#supression du texte dans mainfield
		self.mainfield.delete(1.0, END)
		#operation de generation aleatoire
		try:	#essaye de convertir les donnes de l'entre en integer
			n = int(self.genentryrand.get())
		except:	#si pas possible, prend la valeur par dfault
			n=20
		if n in ['', ' ', 0]:
			n=20
		count=0
		while count < n:
#			p1 = randrange(len(self.p1))
#			p2 = randrange(len(self.p2))
#			p3 = randrange(len(self.p3))
#			p4 = randrange(len(self.p4))
			if p1 != ['']:
				n1=randrange(len(self.p1))
			else:
				n1=0
			if p2 != ['']:
				n2=randrange(len(self.p2))
			else:
				n2=0
			if p3 != ['']:
				n3=randrange(len(self.p3))
			else:
				n3=0
			if p4 != ['']:
				n4=randrange(len(self.p4))
			else:
				n4=0
			txt= p1[n1]+space1+p2[n2]+space2+p3[n3]+space3+p4[n4]
			self.mainfield.insert(END, txt)
			self.mainfield.insert(END, '\n')
			count += 1
	#----Methode de lancer de des
	def lancer(self):
		try:
			nbdes=int(self.nbdesentry.get())
			valdes=int(self.valdesentry.get())
		except:
			print 'Valeurs incorrectes'
		if ( nbdes > 0 ) and ( valdes > 0):
			tmptxt=''
			i=0
			jmem=0
			while i < nbdes:
				j=randrange(valdes)+1
				jmem=jmem+j
				if tmptxt == '':
					tmptxt=str(j)
				else:
					tmptxt=tmptxt+'+'+str(j)
				i += 1
			restext=tmptxt+' = '+str(jmem)
			self.desreslab.configure(text=restext)
#test
a = Appli()
a.fen.mainloop()
		


