# -*- coding:Latin-1 -*-
#Utilitaire pour fractionner un liste de nom contenue dans un fichier

from Tkinter import *
class Application:
	def __init__(self):
		self.fen=Tk()
		self.fen.title('NameCutter')
		self.fen.resizable(width=FALSE,height=FALSE)
		#++++Entre du nom du fichier
		#==LabelFrame
	#	self.filenameframe=LabelFrame(self.fen,text='Nom du fichier',padx=169,pady=5)
	#	self.filenameframe.grid(row=0,column=0,columnspan=2)
		#==Entre
	#	self.filename = Entry(self.filenameframe,bg='white')
	#	self.filename.pack()
	#	self.filename.bind("<Return>", self.openfile)
		#++++Premier champ texte (le texte  mettre en liste)
		#==LabelFrame
		self.originaltextframe=LabelFrame(self.fen,text='Texte original',padx=5,pady=5)
		self.originaltextframe.grid(row=1,column=0,columnspan=2)
		#==Text & scrollbar
		self.originaltext=Text(self.originaltextframe,setgrid=1, height=10, width=64, bg='white')
		self.originaltext.pack(side=LEFT)
		self.originaltextscroll=Scrollbar(self.originaltextframe, command=self.originaltext.yview)
		self.originaltext.configure(yscrollcommand=self.originaltextscroll.set)
		self.originaltextscroll.pack(side=LEFT, fill='y')

		#++++Convertion options
		#==LabelFrame
		optionpadx = 72
		self.optionsframe=LabelFrame(self.fen,text='Options',padx=optionpadx,pady=5)
		self.optionsframe.grid(row=2,column=0,columnspan=2)
		#==Entry pour sparateur et label + frame
		self.optionssubframe=Frame(self.optionsframe)
		self.optionssubframe.pack(side=LEFT)
		Label(self.optionssubframe,text='Sparateur : ').pack(side=LEFT)
		self.separateurentry=Entry(self.optionssubframe, width=3, bg='white')
		self.separateurentry.pack(side=LEFT)
		#==Bouton convertir
		Button(self.optionsframe,text='Convertir',command=self.splitlist).pack(side=LEFT,padx=optionpadx)

		#++++Entre du nom  sparer + option
		namepadx=49
		#==LabelFrame
		self.nameentryframe=LabelFrame(self.fen,text='Nom  sparer',padx=namepadx, pady=5)
		self.nameentryframe.grid(row=3,column=0,columnspan=2)
		#==checkbox capitalize
		self.capitalvar=IntVar()
		self.capitalchckbox=Checkbutton(self.nameentryframe, text='Capitale', variable=self.capitalvar)
		self.capitalchckbox.grid(row=0, column=0,padx=namepadx)
		#==Entre
		self.nameentryvar=StringVar()
		self.nameentry=Entry(self.nameentryframe,textvariable=self.nameentryvar,width=16,bg='white')
		self.nameentry.grid(row=0, column=1,padx=namepadx)
		self.nameentry.bind("<Return>", self.separate)

		#++++Texte P1
		ptextpadx=20
		#==LabelFrame
		self.p1labelframe=LabelFrame(self.fen,text='1re partie', padx=ptextpadx, pady=5)
		self.p1labelframe.grid(row=4,column=0)
		#==text & scrollbar
		self.p1text=Text(self.p1labelframe, setgrid=1, width=24, bg='white')
		self.p1text.pack(side=LEFT)
		self.p1scroll=Scrollbar(self.p1labelframe, command=self.p1text.yview)
		self.p1text.configure(yscrollcommand=self.p1scroll.set)
		self.p1scroll.pack(side=LEFT,fill='y')

		#++++Texte P2
		#==LabelFrame
		self.p2labelframe=LabelFrame(self.fen,text='2eme partie', padx=ptextpadx, pady=5)
		self.p2labelframe.grid(row=4,column=1)
		#==text & scrollbar
		self.p2text=Text(self.p2labelframe, setgrid=1, width=24, bg='white')
		self.p2text.pack(side=LEFT)
		self.p2scroll=Scrollbar(self.p2labelframe, command=self.p2text.yview)
		self.p2text.configure(yscrollcommand=self.p2scroll.set)
		self.p2scroll.pack(side=LEFT,fill='y')

		#++++Sauvegarde
		savepadx=6
		savepady=5
		#==LabelFrame
		self.sauvegardeframe=LabelFrame(self.fen,text='Sauveguarde',padx=savepadx,pady=savepady)
		self.sauvegardeframe.grid(row=5,column=0,columnspan=2)
		#==entre plus label nom de la race + frame
		self.raceframe=Frame(self.sauvegardeframe)
		self.raceframe.grid(row=0, column=0, columnspan=2,pady=savepady)
		Label(self.raceframe,text='Nom de la race : ').pack(side=LEFT)
		self.raceentry=Entry(self.raceframe,width=16,bg='white')
		self.raceentry.pack(side=LEFT)
		#==entre plus label nom de la particule 1 plus bouton save + frame
		self.p1saveframe=Frame(self.sauvegardeframe)
		self.p1saveframe.grid(row=1, column=0,padx=savepadx,pady=savepady)
		Label(self.p1saveframe,text='Num de la particule : ').pack(side=LEFT)
		self.p1entry=Entry(self.p1saveframe,width=3,bg='white')
		self.p1entry.pack(side=LEFT)
		self.p1boutonsave=Button(self.p1saveframe,text='Save',command=self.savep1)
		self.p1boutonsave.pack(side=LEFT)
		#==entre plus label nom de la particule 2 plus bouton save + frame
		self.p2saveframe=Frame(self.sauvegardeframe)
		self.p2saveframe.grid(row=1, column=1,padx=savepadx,pady=savepady)
		Label(self.p2saveframe,text='Num de la particule : ').pack(side=LEFT)
		self.p2entry=Entry(self.p2saveframe,width=3,bg='white')
		self.p2entry.pack(side=LEFT)
		self.p2boutonsave=Button(self.p2saveframe,text='Save',command=self.savep2)
		self.p2boutonsave.pack(side=LEFT)
		
		#==variables diverses
		self.textlist=[]
		self.numname=0
		self.openfile2()

	#--------METHODES
	#++++Openfile
	#def openfile(self, event):
	#	try:
	#		filename=self.filename.get()
	#		opfile=open(filename, 'r')
	#		readfile=opfile.read()
	#		self.originaltext.delete(1.0,END)
	#		self.originaltext.insert(END, readfile)
	#		opfile.close()
	#		self.textlist=[]
	#	except:
	#		None
	#++++Openfile
	def openfile2(self):
		try:
			opfile=open('./NameCutter.txt', 'r')
			readfile=opfile.read()
			self.originaltext.delete(1.0,END)
			self.originaltext.insert(END, readfile)
			opfile.close()
			self.textlist=[]
		except:
			None
	#++++SplitList
	def splitlist(self):
		#def du separateur
		separator=self.separateurentry.get()
		if separator == '':
			separator=' '
		#spliting
		if separator == '\R':
			print 'separator spcial'
			maxline=self.originaltext.index(END)
			maxline=maxline.split('.')
			maxline=maxline[0]
			print maxline
			maxline = int(maxline)
			numlineint=1
			while numlineint <= maxline:
				indstart=str(numlineint)+'.0'
				indend=str(numlineint)+'.end'
				txt=self.originaltext.get(indstart, indend)
				self.textlist.append(txt)
				numlineint += 1
		else:
			self.textlist=self.originaltext.get(1.0,END).split(separator)
		print self.textlist
		#eliminations des entres inutiles
		n=0
		while n < len(self.textlist):
			if self.textlist[n] in [' ', '', '\n']:
				del(self.textlist[n])
			else:
				n += 1
		self.numname=0
		self.affichernom()
	#++++Afficher nom
	def affichernom(self):
		if self.numname < len(self.textlist):
			self.nameentryvar.set(self.textlist[self.numname])
			self.numname += 1
	#++++Separate
	def separate(self, event):
		index=self.nameentry.index(INSERT)
		entryget=self.nameentry.get()
		p1var=entryget[:index]
		if self.capitalvar.get() == 1:
			p1var=p1var.lower()
			p1var=p1var.capitalize()
		else:
			p1var=p1var.lower()
		p2var=entryget[index:]
		p2var=p2var.lower()
		self.p1text.insert(END, p1var+'\n')
		self.p2text.insert(END, p2var+'\n')
		self.affichernom()

	#++++SaveP1
	def savep1(self):
		p1list=['0']
		p1list=self.p1text.get(1.0,END).split('\n')
		racename=self.raceentry.get()
		partnum=self.p1entry.get()
		p1savefile=open(racename+'_P'+partnum+'.txt', 'w')
		#limination des entre inutiles
		i=0
		while i < len(p1list):
			if p1list[i] in [' ','','\n']:
				del(p1list[i])
			else:
				i += 1
		p1list.sort()
		#limination des doublons
		i,j=0,0
		while i < len(p1list):
			j=0
			while j < len(p1list):
				if (i != j) and ( p1list[i] == p1list[j]):
					del(p1list[j])
				else:
					j += 1
			i += 1
		#ecriture
		print p1list
		for i in range(len(p1list)):
			tmptxt=p1list[i]
			if tmptxt == p1list[-1]:
				p1savefile.write(tmptxt)
			else:
				p1savefile.write(tmptxt+'\n')
		p1savefile.close

	#++++SaveP2
	def savep2(self):
		p2list=self.p2text.get(2.0,END).split('\n')
		racename=self.raceentry.get()
		partnum=self.p2entry.get()
		p2savefile=open(racename+'_P'+partnum+'.txt', 'w')
		#limination des entre inutiles
		i=0
		while i < len(p2list):
			if p2list[i] in [' ','','\n']:
				del(p2list[i])
			else:
				i += 1
		p2list.sort()
		#limination des doublons
		i,j=0,0
		while i < len(p2list):
			j=0
			while j < len(p2list):
				if (i != j) and ( p2list[i] == p2list[j]):
					del(p2list[j])
				else:
					j += 1
			i += 1
		#ecriture
		print p2list
		
		for i in range(len(p2list)):
			tmptxt=p2list[i]
			if tmptxt == p2list[-2]:
				p2savefile.write(tmptxt)
			else:
				p2savefile.write(tmptxt+'\n')
		p2savefile.close
			
#Lancement
a=Application()
a.fen.mainloop()
